#include "testApp.h"

//---------------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------------
void testApp::setup()
{
	ofSetWindowTitle("chart");

	// Ot̃f[^ǂݍ
	Load();

	// OtXN[
	offset = 0;
	cursorIndex = -1;

	// Ot`̈
	graphRect.set(10, 10, 800, 600);

	int x = 160, y = 630;
	int w = 80, h = 20;

	// X^[g{^
	startText = "start";
	startTextPos.set(x + 20, y + h - 5);
	startRect.set(x, y, w, h);

	// Xgbv{^
	x += 400;
	stopText = "stop";
	stopTextPos.set(x + 25, y + h - 5);
	stopRect.set(x, y, w, h);

	// Ԍv
	startTime = -1;
	ellapsedTime = 0;
}

//---------------------------------------------------------------------------------
// XV
//---------------------------------------------------------------------------------
void testApp::update()
{
	if (startTime > 0)
	{
		ellapsedTime = (clock() - startTime) / 1000;
	}
}

//---------------------------------------------------------------------------------
// `
//---------------------------------------------------------------------------------
void testApp::draw()
{
	// Otwi
	ofSetColor(255);
	ofRect(graphRect);

	// ܂Ot
	ofSetColor(0);
	for (int i = 0; i < data.size(); i++)
	{
		int x = ConvertX(i);
		int y = ConvertY(data[i].second);
		ofLine(ofPoint(x, y), ofPoint(x, y + 1));
	}

	// J[\ʒũnCCg
	if (cursorIndex < 0) cursorIndex = 0;
	if (data.size() <= cursorIndex) cursorIndex = data.size() - 1;
	int x = ConvertX(cursorIndex);
	int y = ConvertY(data[cursorIndex].second);
	ofSetColor(255, 0, 0, 255);
	ofLine(ofPoint(x, y - 5), ofPoint(x, y - 15));
	
	// oߎԕ\
	ofSetColor(255, 0, 0, 255);
	ostringstream oss1;
	oss1 << (int)ellapsedTime << " s";
	ofDrawBitmapString(oss1.str(), graphRect.x + 10, graphRect.y + 20);
	
	// J[\ʒũf[^\
	ostringstream oss2;
	oss2 << data[cursorIndex].first << " " << data[cursorIndex].second;
	ofDrawBitmapString(oss2.str(), graphRect.x + graphRect.width - 150, graphRect.y + 20);

	// vJnEI{^
	ofSetColor(230);
	ofRect(startRect);
	ofRect(stopRect);
	ofSetColor(0);
	ofDrawBitmapString(startText, startTextPos);
	ofDrawBitmapString(stopText, stopTextPos);
}

//---------------------------------------------------------------------------------
// hbOꂽ
//---------------------------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button)
{
	if (button == 0)	// NbN
	{
		cursorIndex = ConvertXInverse(x);
	}
	if (button == 2)	// ENbN
	{
		offset += x - startPoint.x;
		startPoint.set(x, y);
	}
}

//---------------------------------------------------------------------------------
// }EX{^ꂽ
//---------------------------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button)
{
	if (graphRect.inside(x, y))	// OẗŃNbNꂽ
	{
		if (button == 0) cursorIndex = ConvertXInverse(x);	// NbN
		if (button == 2) startPoint.set(x, y);				// ENbN
	}
	if (startRect.inside(x, y))	// X^[g{^NbNꂽ
	{
		if (button == 0)	// NbN
		{
			ellapsedTime = 0;
			startTime = clock();
		}
	}
	if (stopRect.inside(x, y))	// Xgbv{^NbNꂽ
	{
		if (button == 0) startTime = -1;	// NbN	
	}
}

//---------------------------------------------------------------------------------
// f[^̓ǂݍ
//---------------------------------------------------------------------------------
void testApp::Load()
{
	std::ifstream file("data/data.csv");
	std::string line;
	std::getline(file, line);
	while (std::getline(file, line))
	{
		char key[256];
		double value;
		int cnt = sscanf(line.substr(line.find(',') + 1).c_str(), "%lf", &value);
		if (cnt >= 1) data.push_back(make_pair(line.substr(0, line.find(',')), value));
	}
}